<html>
<head><title>Test Server Java</title><head>
<body><pre><?php

$thisdir = dirname(__FILE__);

//---------------------------------------------------------------------
// If Java is not in the PATH you can specify JRE directory explicitly.
// Here are different methods to define it:
//---------------------------------------------------------------------
//$java_home = "$thisdir/jre"; // in this directory 
//$java_home = "~/jre"; // in the root of current Linux user
//$java_home = dirname($_SERVER['DOCUMENT_ROOT']).'/jre'; // next to the website root
//$java_home = getenv('JAVA_HOME').'/jre'; // specified by JAVA_HOME environment variable
//$java_home = ... // specify as absolute path

if (isset($java_home)) {
    if (!is_dir($java_home)) exit("Can't find the directory $java_home");
    $java = "$java_home/jre/bin/java";
}
else $java = "java"; // if $java_home is not specified assume it's in the PATH

if (is_file("$thisdir/Test.class")) { // check the class file exists
    $descriptor = array(
	1 => array('pipe','w'), // stdout
	2 => array('pipe','w')  // stderr
    );
    $process = proc_open("$java -Xms16M -Xmx16M -cp $thisdir Test", $descriptor,
			  $pipes, $thisdir, NULL, array("bypass_shell"=>TRUE) );
    if (is_resource($process)) {
	// output stdout as response
	echo stream_get_contents($pipes[1]);
	fclose($pipes[1]);

	// output stderr as response
	echo stream_get_contents($pipes[2]);
	fclose($pipes[2]);

	$return_value = proc_close($process);
	if ($return_value != 0) {
	    echo "\n";
	    if ($return_value != 0) {
		echo "\n\n";
		switch($exit_code) {
		    case 127: echo "Can't find $java"; break;
		    case 126: echo "Not enough permissions to run $java (755 is required)"; break;
		    default:  echo "return_value: $return_value";
		}
	    }
	}
    }
    else exit('failed to open proceess');
}
else exit("Error: Can't find $thisdir/Test.class");

?></pre></body>
</html>